diff a/test/jdk/valhalla/valuetypes/WeakReferenceTest.java b/test/jdk/valhalla/valuetypes/WeakReferenceTest.java
--- /dev/null
+++ b/test/jdk/valhalla/valuetypes/WeakReferenceTest.java
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2019, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+import java.lang.ref.WeakReference;
+import java.lang.ref.ReferenceQueue;
+
+import jdk.internal.vm.annotation.ImplicitlyConstructible;
+import org.testng.annotations.Test;
+import static org.testng.Assert.*;
+
+/*
+ * @test
+ * @summary Test value classes with Reference types
+ * @enablePreview
+ * @run testng/othervm WeakReferenceTest
+ */
+@Test
+public class WeakReferenceTest {
+    @ImplicitlyConstructible
+    static value class Value {
+    }
+
+    @Test(expectedExceptions = IdentityException.class)
+    static void test1() {
+        Value v = new Value();
+        WeakReference<Value> r = new WeakReference<>(v);
+    }
+
+    @Test(expectedExceptions = IdentityException.class)
+    static void test2() {
+        ReferenceQueue<Object> q = new ReferenceQueue<>();
+        Value v = new Value();
+        WeakReference<Value> r = new WeakReference<>(v, q);
+    }
+}
